/***************************************************************************
 *   Copyright (C) 2006 by John Schneiderman                               *
 *   JohnMS@member.fsf.org                                                 *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA.             *
 ***************************************************************************/
#include "sally.h"
#include "generalgameai.h"

Sally::Sally(): AIBase()
{}

Sally::~Sally()
{}

CardSequence Sally::whichCards(const QString& game, const CardSequence& playSequence, const RuleBase& rules, const CardSequence& hand) const
{
    CardSequence cards;

    if (game == "cribbage")
    {
        GeneralGameAI ai(playSequence, rules, hand);
        cards=ai.selectCards(1);
    }
    else if (game == "cribbageDealerCrib")
    {
        GeneralGameAI ai(playSequence, rules, hand);
        cards=ai.randomCardsWithNoLegalChecks(2);
    }
    else if (game == "cribbageNonDealerCrib")
    {
        GeneralGameAI ai(playSequence, rules, hand);
        cards=ai.randomCardsWithNoLegalChecks(2);
    }
    else if (game == "heartsPassPhase")
    {
        GeneralGameAI ai(playSequence, rules, hand);
        cards=ai.randomCardsWithNoLegalChecks(3);
    }
    else
    {
        GeneralGameAI ai(playSequence, rules, hand);
        cards=ai.selectCards(1);
    }
    return cards;
}

Player::skill_Level Sally::skillLevel(const QString& game) const
{
    if (game == "I don't know any games yet")
        return Player::Skill_Error;
    else
        return Player::Newb;
}

QString Sally::name() const
{
    return "Sally";
}
